package mimuw.lab1;

public class Graph {

    private static final int MAX_SIZE = 10;

    private boolean[][] relations = new boolean[MAX_SIZE][MAX_SIZE];

    private int[] values = new int[MAX_SIZE];

    private int nodes = 0;

    public int addNode(int value) {
        if (nodes == MAX_SIZE)
            return -1;
        values[nodes++] = value;
        return nodes - 1;
    }

    public int readValue(int node) {
        return values[node];
    }

    public void addEdge(int node1, int node2) {
        relations[node1][node2] = relations[node2][node1] = true;
    }

    public int getRoot() {
        if (nodes == 0)
            return -1;
        return 0;
    }

    public int[] getNeighbors(int node) {
        int count = 0;
        for (boolean isNeighbor : relations[node]) {
            if (isNeighbor)
                count++;
        }
        int[] neighbors = new int[count];
        count = 0;
        for (int i = 0; i < MAX_SIZE; i++) {
            if (relations[node][i])
                neighbors[count++] = i;
        }
        return neighbors;
    }
}
