package mimuw.lab1;

public class Queue {

    private int[] data = new int[10];

    private int begin = 0, end = 0;

    public boolean push(int x) {
        if (size() == data.length - 1)
            return false;
        data[end] = x;
        end = (end + 1) % data.length;
        return true;
    }

    public int pop() {
        if (this.empty())
            return -1;
        int x = data[begin];
        begin = (begin + 1) % data.length;
        return x;
    }

    public int peek() {
        if (empty())
            return -1;
        return data[begin];
    }

    public int size() {
        if (empty())
            return 0;
        int diff = end - begin;
        if (diff > 0)
            return diff;
        else
            return data.length + diff;
    }

    public boolean empty() {
        return begin == end;
    }

    public void clear() {
        begin = end = 0;
    }
}
